import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkConfig, ThinkConfigParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkConfig(params: ThinkConfigParam) {
  const res = await request.get<ApiResult<PageResult<ThinkConfig>>>(
    THINK_API_URL + '/think/think-config/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkConfig(params?: ThinkConfigParam) {
  const res = await request.get<ApiResult<ThinkConfig[]>>(
    THINK_API_URL + '/think/think-config',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkConfig(data: ThinkConfig) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-config',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkConfig(data: ThinkConfig) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-config',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkConfig(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-config/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkConfig(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-config/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkConfig(id: number) {
  const res = await request.get<ApiResult<ThinkConfig>>(
    THINK_API_URL + '/think/think-config/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
